(set-info :smt-lib-version 2.6)
(set-logic AUFNIA)
(set-info :source |Generator: Rodin SMT Plug-in|)
(set-info :license "https://creativecommons.org/licenses/by-nc/4.0/")
(set-info :category "industrial")
(set-info :status unsat)

(declare-sort PZ 0)
(declare-fun MS (Int PZ) Bool)
(declare-fun s (Int Int) Bool)
(declare-fun n () Int)

; Elementary Sets axiom (Singleton part)
(assert (forall ((x21 Int)) 
            (exists ((X PZ)) 
                (and 
                    (MS x21 X) 
                    (forall ((y Int)) 
                        (=> 
                            (MS y X) 
                            (= y x21)))))))
(assert (! (forall ((q PZ)) 
               (=> 
                   (and 
                       (forall ((x Int)) 
                           (=> 
                               (MS x q) 
                               (<= 0 x))) 
                       (exists ((x0 Int)) 
                           (and 
                               (= x0 0) 
                               (MS x0 q))) 
                       (forall ((n0 Int)) 
                           (=> 
                               (MS n0 q) 
                               (exists ((x1 Int)) 
                                   (and 
                                       (= x1 (+ n0 1)) 
                                       (MS x1 q)))))) 
                   (forall ((x2 Int)) 
                       (=> 
                           (<= 0 x2) 
                           (MS x2 q)))))
         :named hyp1))
(assert (! (and 
               (forall ((x3 Int) (x4 Int)) 
                   (=> 
                       (s x3 x4) 
                       (and 
                           (<= 0 x3) 
                           (<= 0 x4)))) 
               (forall ((x5 Int) (x6 Int) (x7 Int)) 
                   (=> 
                       (and 
                           (s x5 x6) 
                           (s x5 x7)) 
                       (= x6 x7))) 
               (forall ((x8 Int)) 
                   (=> 
                       (<= 0 x8) 
                       (exists ((x9 Int)) 
                           (s x8 x9)))))
         :named hyp2))
(assert (! (exists ((x10 Int) (x11 Int)) 
               (and 
                   (= x10 0) 
                   (= x11 0) 
                   (s x10 x11)))
         :named hyp3))
(assert (! (exists ((x12 Int) (x13 Int)) 
               (and 
                   (= x13 0) 
                   (s x13 x12)))
         :named hyp4))
(assert (! (forall ((x14 Int) (x15 Int) (x16 Int)) 
               (=> 
                   (and 
                       (s x14 x15) 
                       (s x14 x16)) 
                   (= x15 x16)))
         :named hyp5))
(assert (! (forall ((n1 Int)) 
               (=> 
                   (<= 0 n1) 
                   (exists ((x17 Int) (x18 Int)) 
                       (and 
                           (= x17 (+ n1 1)) 
                           (forall ((x19 Int)) 
                               (=> 
                                   (s n1 x19) 
                                   (= x18 (+ x19 n1 1)))) 
                           (s x17 x18)))))
         :named hyp6))
(assert (! (<= 0 n)
         :named hyp7))
(assert (! (not 
               (forall ((x20 Int)) 
                   (=> 
                       (s n x20) 
                       (= (* 2 x20) (* n (+ n 1))))))
         :named goal))
(check-sat)
(exit)

